<?php
require_once("utilities.php");
require_once("category.php");
require_once('facebook_app.php');
FacebookApp::instance()->ensureFacebookUserLoggedInToVB();

final class CategoryItem {

    // + Singleton implementation
    private static $instance = null;
    public static function instance() {
        if(!isset(self::$instance)) {
            self::$instance = new CategoryItem();
        }
        return self::$instance;
    }
	private function __construct() {
        
    }
    // - Singleton implementation
    
    private $data;
    
    public function renderItem($category, $id, $page) {
        echo CategoryContentItem::get($category, $id, $page)->getHtml();
        return time() + 3;
    }
    public function getOGMetasForItem($category, $id, $page) {
        return CategoryContentItem::get($category, $id, $page)->getOGTags();
    }
    public function renderSidebar($category, $id) {
        $category = Category::registry($category);
        $i = 2;
		$hash = array($id => true);
        foreach(array_slice($category->getData(), 0, 6) as $data_item) {
            if($i > 5) break;
			if(!isset($hash[$data_item->getId()])) {
				$hash[$data_item->getId()] = true;
				echo $data_item->getSingleSidebarHtml($i++);
			}
        }
    }
}
if(!isset($_GET['category']) || !isset($_GET['id'])) {
    header('HTTP/1.1 404 Not Found');
    header('Connection: close');
    exit;
}

$page = (!empty($_GET['page']) ? $_GET['page'] : 1);

if(defined('READ_ONLY') && READ_ONLY) {
    header('HTTP/1.1 301 Moved Permanently');
    header('Location: ' . vB_SITE_ROOT . CategoryContentItem::getRedirect($_GET['category'], $_GET['id'], $page));
    header('Connection: close');
    exit;
}

if(!isset($_GET['do'])) {
display_header(array('_css/editor.css'), array('_js/editor.js'), CategoryItem::instance()->getOGMetasForItem($_GET['category'], $_GET['id'], $page));
?>

<div id="dbcontent"> 
<div id="single_item_view">
    <div id="box_view" class="single">
        <?php 
            ob_start();
            $expires_timestamp = CategoryItem::instance()->renderItem($_GET['category'], $_GET['id'], $page);
        ?>
        <div class="sidebar">
            <ul>
            <?php 
                CategoryItem::instance()->renderSidebar($_GET['category'], $_GET['id'])
            ?>
            </ul>
        </div>
        <div style="clear: both"></div>
        <?php
            $out = Category::registry($_GET['category'])->getSingleItemContainerHtml('<li class="single_content_item">' . ob_get_contents() . '</li>');
            ob_end_clean();
        ?>
        <div class="divider">
        <?php
            echo $out;
        ?>
        </div>
    </div>   
</div>
</div>
<?php 
display_footer($expires_timestamp);
} else if ($_GET['do'] == 'updatesidebar') {
    cache_start();
    cache_end(CategoryItem::instance()->renderSidebar($_GET['category']));
} else if ($_GET['do'] == 'updateitem') {
    cache_start();
    cache_end(CategoryItem::instance()->renderItem($_GET['category'], $_GET['id'], $page));
}
?>
